ghc-7.10.3: The GHC API

Safe Haskell | None
Language | Haskell2010

FunDeps

# Documentation

data FDEq

Constructors

FDEq |

Fields

fd_pos :: Int
fd_ty_left :: Type
fd_ty_right :: Type

Instances

Outputable FDEq |

data Equation loc

Constructors

FDEqn |

Fields

fd_qtvs :: [TyVar]
fd_eqs :: [FDEq]
fd_pred1, fd_pred2 :: PredType
fd_loc :: loc

pprEquation :: Equation a -> SDoc

improveFromInstEnv :: InstEnvs -> PredType -> [Equation SrcSpan]

improveFromAnother :: PredType -> PredType -> [Equation ()]

checkInstCoverage :: Bool -> Class -> [PredType] -> [Type] -> Validity

checkFunDeps :: InstEnvs -> ClsInst -> Maybe [ClsInst]

pprFundeps :: Outputable a => [FunDep a] -> SDoc